//#region 宣言
const w_IMG=2100,h_IMG=3000;
const color_sel = "#f99";//ボーダー色


const el_scroll = document.scrollingElement;

let timer_menu=null;
let timer_float=null;

let x_touch = 0,x_move=0;
let y_touch = 0,y_move=0;
let time_start=0,time_end=0;//getTime

const el_doc=document.documentElement;
let i_sel = 0,l_imgs=arr_jpg.length;
let image_pre = new Image();//画像先読み

let i_pre=0;
let arr_pre = new Array(l_imgs + 1);
for (i = 0; i < l_imgs; i++)arr_pre[i] = false;
arr_pre[l_imgs] = true;

let str_3 = "000";
let _support = false;
let arr_lay = [];

let zoom_now=100,zoom_min=50;
let x_scroll=50,y_scroll=0,w_over=0,h_over=0,w_img=0,h_img=0;

const str_none="";

const $ = id => document.getElementById(id);
const $log = msg => console.log(msg);


//機種判別
let i_dpr=devicePixelRatio;
let _ua = navigator.userAgent;
let _pf =navigator.platform;
let _device="";
let _browser="Chrome";//仮
if (_pf.charAt(0) == "i"){
	_device="iOS";
	if(_ua.indexOf("CriOS")<0)_browser="Safari";
}else if(_pf=="Win32"&&innerHeight==screen.height)_device="Dev";
else if(_pf.slice(0,3)=="Win"){
	_device="Win";
	if(_ua.indexOf("Edge")>0)_browser="Edge";
	else if(_ua.indexOf("Trident")>0)_browser="IE11";
	else if(_ua.indexOf("Firefox")>0)_browser="Firefox";
	else if(_ua.indexOf("Chrome")<0)_browser="";
}
else if(_ua.indexOf('Android')>0)_device="Android";
else if(_pf=="MacPPC")_device="Mac";
if(_device=="")_device="unknown";

let bool_land=false;//横持ちかどうか
let w_land=0,w_port=0;//width
let w_view=0,h_view=0;//表示範囲
let w_area=0,h_area=0;//タップ範囲
let zoom_land=0,zoom_port;//zoom_min

if(_device=="Dev")window.addEventListener("resize",ResizeDev);
else if(_device=="Android")window.addEventListener("resize",ResizeAndroid);
window.addEventListener("orientationchange", OrientationChange);
document.addEventListener("keydown", KeyDown);


/** @type {Array.<HTMLImageElement>} */ let arr_img;

/** @type {HTMLImageElement} */let IMG;
/** @type {HTMLImageElement} */let IMG1;
/** @type {HTMLImageElement} */let img_bar;

/** @type {HTMLDivElement} */let div_img;
/** @type {HTMLDivElement} */let div_ui;
/** @type {HTMLDivElement} */let div_slider;
/** @type {HTMLDivElement} */let div_list;
/** @type {HTMLSpanElement} */let span_zoom;
/** @type {HTMLParagraphElement} */let p_page;
/** @type {HTMLParagraphElement} */let p_msg;
/** @type {HTMLParagraphElement} */let p_float;
/** @type {HTMLInputElement} */let input_range;
/** @type {HTMLInputElement} */let input_tel;

//#endregion 宣言

document.addEventListener("DOMContentLoaded",DOMContentLoaded);
function DOMContentLoaded(){
	//#region getID =$("");
	IMG=$("IMG");
	IMG1 = $("IMG1");
	img_bar=$("img_bar");
	div_list=$("div_list");
	div_img=$("div_img");
	div_ui=$("div_ui");
	div_slider=$("div_slider");
	span_zoom=$("span_zoom");
	input_range=$("input_range");
	input_tel = $("input_tel");
	p_page=$("p_page");
	p_msg=$("p_msg");
	p_float=$("p_float");
	//#endregion

	



	if(_device=="iOS"){
		div_img.addEventListener("touchstart",Touchstart,{passive:false});
		div_img.addEventListener("touchend",Touchend,{passive:false});
		div_img.addEventListener("touchmove",Touchmove,{passive:false});
	}else{
		div_img.addEventListener("touchstart",Touchstart,false);
		div_img.addEventListener("touchend",Touchend,false);
		div_img.addEventListener("touchmove",Touchmove,false);
	}
	
	IMG.addEventListener("load", $OnloadIMG);
	image_pre.addEventListener("load", $OnloadPre);

	img_bar.addEventListener("touchstart",TouchBar);
	input_range.addEventListener('input',Input);
	p_page.addEventListener("touchstart",()=>{scrollTo(0, 0);});

	let htm="";
	for (let i = 0; i < l_imgs; i++)
		htm += "<img src='s/" + arr_jpg[i] + ".jpg' alt=" + i + ">";
	div_list.insertAdjacentHTML('beforeend',htm);
	arr_img=div_list.children;
	div_list.addEventListener("click",ClkDivList);

	let spans=div_slider.getElementsByTagName("span");
	for(let span of spans)span.addEventListener("click",ClkSpan);

	SelIMG(0);
	CalcZoom();

	l = arr_png.length;
	let t = ""; let k = 0; let j = 0;
	for (i = 0; i < l; i++) {
		t = arr_png[i];
		if (t[0] == "_") {
			j = t.indexOf("_", 1);
			k = t.slice(1, j) * 1 - 1;
			arr_lay[k] = t.slice(j + 1);
		} else {
			j = t.indexOf("_");
			k = t.slice(0, j) * 1 - 1;
			arr_lay[k] = t;
		}
	}

	let d = new Date();
	let m = d.getMonth() + 1;
	let y = d.getFullYear() - 2000;
	t = (y - m) << (8 + y % 8 + m);
	str_3 = t.toString().slice(-4, -1);

	let tel = localStorage.getItem("tel");
	if (tel != null) {
		if (tel == str_3) {
			$Support();
			input_tel.value = tel;
		}
		else {
			localStorage.removeItem("tel");
			i_code.innerText = "今月のコードを入力して下さい";
		}
	}
	input_tel.addEventListener('input', $Chk_tel);
	if(_device=="Android"){
		input_tel.addEventListener('focus', function () { div_ui.style.visibility = "hidden"});
		input_tel.addEventListener('blur', function () { div_ui.style.visibility = "" });
	}
	
	htm = "表示環境"+_device +",ブラウザ"+_browser+ "<br>推定解像度 dpr" + i_dpr + " x width" + w_port + "=" + i_dpr*w_port+"px";

	i_code.innerHTML =htm;
}

function $Support() {
	if (_support) return;
	_support = true;
	i_code.innerText = "支援者向け特典 " + arr_png.length + "枚のCGを上書きしました";
	for (let i = 0; i < l_imgs; i++)if (arr_lay[i])
		arr_img[i].style.borderRadius = "20px";
}




function $Chk_tel(event) {
	let t = input_tel.value;
	if (_support && t == "") {
		
		_support = false;
		i_code.innerText = "特典モードを解除しました";
		for (let i = 0; i < l_imgs; i++)if (arr_lay[i])
			arr_img[i].style.borderRadius = "";
		localStorage.removeItem("tel");
	}

	if (t.length != 3) return;

	if (!_support && t == str_3){
		localStorage.setItem("tel",t);
		$Support();
	}
	
}


//#region IMGev

function $Press(){
	if (x_touch < w_area) SelIMG(i_sel - 1);
	else if (x_touch > w_view - w_area) SelIMG(i_sel + 1);
	else if (zoom_now > zoom_min) {
		ChkScroll();
		SetZoom(-1);
	}
	else return false;
	timer_menu = setTimeout($Press, 500);
}

function $ClearT(timer) {
	if (!timer) return;
	clearTimeout(timer);
	timer = null;
}

/** @param {TouchEvent} event */
function Touchstart(event){
	let et=event.touches;
	if(et.length>1){
		if(_device=="iOS")event.preventDefault();
		if(zoom_now>zoom_min)SetZoom(-1);
		return;
	}
	x_touch =x_move = et[0].clientX;
	y_touch =y_move = et[0].clientY;
	//y_move=y_touch;
	time_start = new Date().getTime();
	if(bool_land)timer_menu=setTimeout(PopMenu,400);
	else timer_menu = setTimeout($Press, 400);
}

/** @param {TouchEvent} event */
function Touchmove(event){
	$ClearT(timer_menu);
	let y=event.changedTouches[0].clientY;
	x_move = event.changedTouches[0].clientX;
	let down=0;
	if(y_move < y)down=1;
	if(y_move > y)down=-1;
	y_move = y;
	y=div_img.scrollTop;
	let vsb=div_ui.style.visibility=="";
	if(down==1&&scrollY<1&&y==0&&event.cancelable)
		event.preventDefault();
	else if(bool_land&&scrollY>20&&vsb)
		div_ui.style.visibility="hidden";
}

/** @param {TouchEvent} event */
function Touchend(event){
	$ClearT(timer_menu);
	let time =new Date().getTime();
	time_end=time;
	time = time_end-time_start;
	let et=event.changedTouches[0];
	let y = et.clientY - y_touch;
	let _y = y; if(_y<0)_y=-_y;
	let x = et.clientX - x_touch;
	let _x = x; if(_x<0)_x=-_x;
	let w=w_area;if(bool_land&&!vsb)w*=2;
	if(time>400){
		if(event.cancelable)event.preventDefault();
		return;
	}
	if(bool_land)clearTimeout(timer_menu);

	let vsb=div_ui.style.visibility=="";

	if(time<200&&_x<3&&_y<3){//タップ
		if(bool_land&&vsb)div_ui.style.visibility="hidden";
		else if (bool_land &&x_touch < w) SelIMG(i_sel - 1);
		else if (bool_land &&x_touch > w_view - w) SelIMG(i_sel + 1);
		else if(bool_land&&y_touch<h_area)SetZoom(0);
		else if(zoom_now<100)SetZoom(2);//拡大
		else if(zoom_now>99)SetZoom(0);
	}
}
//#endregion IMGev

//#region evFunc

/** @param {TouchEvent} event */
function TouchBar(event) {
	let pt = (et=event.touches[0].clientX-div_ui.offsetLeft) * 100 / div_ui.offsetWidth | 0;

	if (pt < 20) SelIMG(i_sel - 1);//prev
	else if (pt < 50) SelIMG(i_sel + 1);//next
	else if (pt > 70){//index
		event.preventDefault();
		JumpIndex(0);
	}
	
}

/** @param {MouseEvent} event */
function ClkDivList(event) {
	let el=event.srcElement;
	if(el.tagName!="IMG")return;
	if(bool_land){
		div_ui.style.visibility="";
		div_img.scrollTop=0;
	}	
	SelIMG(el.alt * 1);
	window.scrollTo(0, 0);
}

/** @param {MouseEvent} event */
function ClkSpan(event){
	let str=event.target.textContent;
	ChkScroll();
	if(str=="+拡大")SetZoom(1);
	else if(str=="縮小－")SetZoom(-1);
	else SetZoom(0);
}

function Input(event) {//changeValue
	let i=input_range.value;
	if(i==0)i=zoom_min;
	else i=100-(input_range.max-i)*10;
	span_zoom.textContent=i+"%";
	ChkScroll();
	SetZoom(i);
}

function ResizeAndroid(event){//Android
	if(!bool_land)return;
	div_img.style.height=innerHeight+"px";
	h_over=h_img-div_img.offsetHeight+4;
}

function ResizeDev(event){//"Dev"
	i_dpr=devicePixelRatio;
	CalcZoom();
}

function OrientationChange(event){
	if (bool_land)div_ui.style.visibility="";
	bool_land=!bool_land;
	if(_device!="Dev")Orientate();
	//_device=="Dev" ResizeDev
}

function KeyDown(event){
	let k=event.keyCode;
	let shift=event.shiftKey;
	if (k == 32 || k > 36 && k < 41){
		window.scrollTo(0, 0);
		event.preventDefault();
	} 

	switch(k){
		case 13:JumpIndex(0);break;//Enter
		case 37:SelIMG(i_sel-1);break;//left
		case 38:SetZoom(shift?0:-1);break;//Up
		case 39:SelIMG(i_sel+1);break;//right
		case 40:SetZoom(shift?100:-1);break;//Down
	}
}



//#endregion evFunc

//#region function

function PopMenu(){
	let x=x_touch-x_move;if(x<0)x=-x;
	let y=y_touch-y_move;if(y<0)y=-y;
	if(x+y<3){
		div_ui.style.visibility="";
		if(scrollY>20)scrollTo(0, 0);
	}
}

function Pfloat(str){
	p_float.textContent=str;
	clearTimeout(timer_float);
	timer_float=setTimeout("p_float.textContent=str_none",1200);
}

function Orientate(){//画面回転
	w_view=bool_land?w_land:w_port;
	h_view=bool_land?w_port:w_land;
	if(i_dpr==3&&w_land>800)w_area=bool_land?100:50;
	else w_area=w_view/10|0;
	h_area=w_port/8|0;

	zoom_min=bool_land?zoom_land:zoom_port;
	input_range.max=10-(zoom_min-zoom_min%10)/10;

	if(bool_land){
		if(_device!="Android")div_img.style.height="";
	}else{
		let h=500;
		if(zoom_min!=33)h=(zoom_min*h_IMG)/(i_dpr*100)|0;
		h+=4;
		div_img.style.height=h+"px";
	}

	x_scroll=50; y_scroll=0; SetZoom(0);

}

function CalcZoom(){//load or ResizeDev zoom_min算出
	let w=innerWidth,h=innerHeight;
	bool_land=w>h;
	if(_device!="Win"){
		w=screen.width;
		h=screen.height;
	}
	w_land=w>h?w:h;
	w_port=w>h?h:w;

	//2100 33:700 40:840 50:1050 60:1260 66:1400 70:1470
	if(i_dpr==2&&(w_port<420&&w_port>349)){//iPh6 or 360*640*2
		zoom_port=30;//33
		zoom_land=60;
	}else if(w_port==600&&i_dpr==1){//k7
		zoom_port=25;zoom_land=40;
	}else {
		zoom_port=(10*i_dpr*w_port/w_IMG|0)*10;
		zoom_land=(10*i_dpr*w_land/w_IMG|0)*10;
	}
 
	if(zoom_port*3>zoom_land*2&&w_port!=600)zoom_port-=20;//iPad

	if(zoom_land>100)zoom_land=100;
	
	Orientate();
}

function JumpIndex(i) {
	if (bool_land){
		div_ui.style.visibility="hidden";
		arr_img[i_sel].scrollIntoView(1);
	}else{//port
		arr_img[i_sel].scrollIntoView(i);
		if (i == 0) window.scrollBy(0, 100);
		else window.scrollBy(0, -50);
	} 
}

function ChkScroll(){
	if(zoom_now>zoom_min){
		x_scroll=(100*div_img.scrollLeft/w_over)|0;
		y_scroll=(100*div_img.scrollTop/h_over)|0;
	}
}

function SetZoom(i){
	let touch=false;let px,py;
	let max=input_range.max*1;
	if(i==0)input_range.value=0;
	else if(i==2){//タップ拡大
		touch=true;
		if(zoom_now==60||zoom_now==80)
			i=input_range.value*1+2;
		else i=input_range.value*1+1;
		
		input_range.value=i;
		i=100-(max-i)*10;
		px=x_touch-IMG.offsetLeft+div_img.scrollLeft;
		py=y_touch+div_img.scrollTop+window.scrollY-2;
		px=i*px/zoom_now|0;
		py=i*py/zoom_now|0;
	}
	else if(i==1||i==-1){//input
		if (i == -1){
			if(zoom_now==100||zoom_now==80)i=-2;
		}
		i=input_range.value*1+i;
		if(i==-1||max<i)return;
		input_range.value=i;
		i=100-(max-i)*10;
	}

	if(i>100)i=100;
	else if(i<zoom_min)i=zoom_min;

	let w=350;
	if(i!=33)w=(i*w_IMG)/(i_dpr*100)|0;
	IMG.style.width=w+"px";w_img=w;
	let h=IMG.height;
	if(h==0)h=(i*h_IMG)/(i_dpr*100)|0;
	h_img=h;
	w_over=w-w_view;
	h_over=h-div_img.offsetHeight+4;

	zoom_now=i;
	if(touch){
		div_img.scrollLeft=px-x_touch;
		div_img.scrollTop=py-y_touch;	
	}else if(zoom_now>zoom_min){
		div_img.scrollLeft=w_over*x_scroll/100|0;
		div_img.scrollTop=h_over*y_scroll/100|0;
	}
	Pfloat(zoom_now+"%");
	span_zoom.textContent=zoom_now+"%";

	w=2;
	if(zoom_now==zoom_min)w=-w_over / 2 | 0;
	div_img.style.paddingLeft =w+"px";


	$OverZoom();
}
function $OverZoom() {
	if (!_support) return;
	if (arr_lay[i_sel]){
		if (zoom_now == 33) IMG1.style.zoom =1/6;
		else IMG1.style.zoom = zoom_now / (100 * i_dpr);
	}
	
}

function $OverLay() {
	if (!_support) return;
	if (arr_lay[i_sel]) {
		let _url = "http://danna.gogo.tc/cgs/1806prp/";
		IMG1.src = _url+"_/" + arr_lay[i_sel] + ".png";
		let t = arr_lay[i_sel].split("_");
		let x = t[1] * 10 ;
		let y = t[2] * 10 ;
		IMG1.style.left = x + "px";
		IMG1.style.top = y + "px";
		$OverZoom();
	}else IMG1.src = "0.png";
}







function SelIMG(i){
	if(i<0)i=l_imgs-1;
	else if(i>l_imgs-1)i=0;

	if (!arr_pre[i]||i > i_sel+1 || i < i_sel-1)
		IMG.src = "s/" + arr_jpg[i] + ".jpg";
	IMG.src = "../JPG/" + arr_jpg[i] + ".jpg";
	
	arr_img[i_sel].style.borderColor = "";
	i_sel = i;
	arr_img[i_sel].style.borderColor = color_sel;

	var str = "";
	if (l_imgs < 100) str ="Page."+ ("00" + (i_sel+1)).slice(-2);	
	else str ="Pg."+("000" + (i_sel + 1)).slice(-3);
	str+="/" + l_imgs;
	if(bool_land&&div_ui.style.visibility!="")Pfloat(str);
	p_page.textContent = str ;

	$OverLay(); $OverZoom();
	
}


function $OnloadIMG() {//preload
	arr_pre[i_sel] = true;
	i = i_sel + 1;
	if (arr_pre[i])return;
	image_pre.src = "../JPG/" + arr_jpg[i] + ".jpg";
	i_pre=i;
}

function $OnloadPre() {
	arr_pre[i_pre] = true;
}




//#endregion